/*******************************************************************
 *
 * File: record.c
 * 
 * Author: Tomasz Stachowiak
 *
 * Description: Record audio to a file in raw format
 *
 * Date: 07.18.96
 *
 *******************************************************************/


#include <stdio.h>
#include <signal.h>
#include <dmedia/audio.h>

#include "params.h"

ALport micro;
ALconfig conf;
FILE *file;
char *buf;
int break_sig = 0;

static void break_come()
{
  break_sig = 1;
}


void print_rate()
{
  long par[2];

  par[0] = AL_INPUT_RATE;
  ALgetparams(AL_DEFAULT_DEVICE, par, 2);
  printf("Input rate: %d\n", par[1]);
}

main()
{
  print_rate();
  buf = malloc(BUF_SIZE);  
  file = fopen("micro.audio", "w");

  signal(SIGINT, break_come);

  if ((conf = ALnewconfig()) == 0)
    fprintf (stderr, "Config allocation error\n");
  if (ALsetchannels(conf, MONO) < 0)
    fprintf (stderr, "Setting channel error\n");
  if (ALsetqueuesize(conf, QSIZE) < 0)
    fprintf (stderr, "Setting queue size error\n");
  if (ALsetwidth(conf, AL_SAMPLE_16) < 0)
    fprintf (stderr, "Setting sample width error\n");

  if ((micro = ALopenport("microphone", "r", conf)) == 0)
    fprintf (stderr, "Port opening error");
 
  while(!break_sig)
    {
      ALreadsamps(micro, buf, BLOCK);
      fwrite(buf, BLOCK*2, 1, file);
    }

  free(buf);
  ALcloseport(micro);
  fclose(file);
}















